



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>基于html5 canvas 的强大图表插件【Chart.js】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">基于html5 canvas 的强大图表插件【Chart.js】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 05:47:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>名词解释</h1>
<p>Chart.js：是基于html5和canvas的强大图表插件，支持多样的图表形式，柱状线性饼环极地雷达等等；</p>
<p>canvas：只兼容到IE9</p>
<p>excanvas.js：强大的第三方兼容插件，可以使canvas兼容到IE5</p>
<h1>链接</h1>
<p>　　<a href="http://chartjs.cn/" rel="external nofollow noreferrer">Chart.js中文网</a></p>
<p>　　<a href="http://chartjs.cn/docs/" rel="external nofollow noreferrer">Chart.js中文文档</a></p>
<h1>代码实现</h1>
<p>第三方引入</p>
<div>
<pre class="prettyprint linenums"> &lt;script src="../js/Chart.js?"&gt;&lt;/script&gt;

    &lt;!--[if lte IE 8]&gt;

    &lt;script src="../js//excanvas.js"&gt;&lt;/script&gt;

    &lt;script&gt;

    Chart.defaults.global.animation = false;

    //这里主要是为&lt;=IE8做降级处理，因为动画在IE8效果很差

    &lt;/script&gt;

    &lt;![endif]--&gt;</pre>
</div>
<p>css</p>
<div>
<pre class="prettyprint linenums">&lt;style type="text/css"&gt;

    html,body,h1,h2,h3,h4,h5,h6 {<br />
    margin: 0;<br />
    padding: 0;<br />
}

.container {<br />
    max-width: 1020px;<br />
    margin: 0px auto;<br />
    margin-bottom: 80px;<br />
}

.chart-wrapper {<br />
    background: #fff;<br />
    padding: 15px;<br />
    max-width: 1020px;<br />
    margin: 0px auto 0px auto;<br />
    box-sizing: border-box;<br />
    overflow: auto;<br />
        /*在手机，支持图表区域的滚动  -webkit-overflow-scrolling: touch*/<br />
    overflow-scrolling: touch;<br />
    -webkit-overflow-scrolling: touch;<br />
}

h2 {<br />
    margin: 20px 0px;<br />
}

.chart-wrapper canvas {<br />
    min-width: 100%;<br />
    height: 260px;<br />
}

.chart-title,

    .chart-wrapper + small {<br />
    margin-left: 15px;<br />
}

    &lt;/style&gt;</pre>
</div>
<p>html</p>
<div>
<pre class="prettyprint linenums"> &lt;body&gt;<br />
  &lt;div class="container"&gt;<br />
   &lt;h2 class="chart-title"&gt;某品牌汽车销量走势&lt;/h2&gt;<br />
   &lt;canvas id="sales-volume-chart"&gt;&lt;/canvas&gt;<br />
   &lt;small&gt;单位：万辆&lt;/small&gt;<br />
  &lt;/div&gt;<br />
  &lt;div class="container"&gt;<br />
   &lt;h2 class="chart-title"&gt;某品牌汽车销量走势&lt;/h2&gt;<br />
   &lt;canvas id="sales-volume-bar-chart"&gt;&lt;/canvas&gt;<br />
   &lt;small&gt;单位：万辆&lt;/small&gt;<br />
  &lt;/div&gt;</pre>
</div>
<p>js</p>
<div>
<pre class="prettyprint linenums">&lt;script&gt;

    function lineChart() {

        var ctx = document.getElementById('sales-volume-chart').getContext("2d")

        var data = {

            labels: ["2014-10", "2014-11", "2014-12", "2015-1", "2015-2", "2015-3"],

            datasets: [{

                label: "",

                fillColor: "rgba(220,220,220,0.2)",

                strokeColor: "rgba(0,102,51,1)",

                pointColor: "rgba(220,220,220,1)",

                pointStrokeColor: "#339933",

                pointHighlightFill: "#339933",

                pointHighlightStroke: "rgba(220,220,220,1)",

                data: [1.27, 1.30, 1.30, 1.41, 1.04, 1.29]

            }]

        };

        // var salesVolumeChart = new Chart(ctx).Line(data);

        var salesVolumeChart = new Chart(ctx).Line(data, {

            // 小提示的圆角

            // tooltipCornerRadius: 0,

            // 折线的曲线过渡，0是直线，默认0.4是曲线

            bezierCurveTension: 0,

            // bezierCurveTension: 0.4,

            // 关闭曲线功能

            bezierCurve: false,

            // 背景表格显示

            // scaleShowGridLines : false,

            // 点击的小提示

            tooltipTemplate: "&lt;%if (label){%&gt;&lt;%=label%&gt; 销量：&lt;%}%&gt;&lt;%= value %&gt;万辆",

            //自定义背景小方格、y轴每个格子的单位、起始坐标

            scaleOverride: true,

            scaleSteps: 9.5,

            // scaleStepWidth: Math.ceil(Math.max.apply(null,data.datasets[0].data) / 0.1),

            scaleStepWidth: 0.05,

            scaleStartValue: 1

        });

    }

    function barChart() {

        var ctx = document.getElementById('sales-volume-bar-chart').getContext("2d")

        var data = {

            labels: ["2014-10", "2014-11", "2014-12", "2015-1", "2015-2", "2015-3"],

            datasets: [{

                label: "",

                fillColor: "rgba(153,204,153,0.5)",

                strokeColor: "rgba(0,102,51,1)",

                pointColor: "rgba(220,220,220,1)",

                pointStrokeColor: "#338033",

                pointHighlightFill: "#338033",

                pointHighlightStroke: "rgba(220,220,220,1)",

                data: [1.27, 1.30, 1.30, 1.41, 1.04, 1.29]

            }]

        };

        var salesVolumeChart = new Chart(ctx).Bar(data, {

            // 点击的小提示

            tooltipTemplate: "&lt;%if (label){%&gt;&lt;%=label%&gt; 销量：&lt;%}%&gt;&lt;%= value %&gt;万辆"

        });

    }

    // 启动

    setTimeout(function() {

        // 避免IE7-8 调用getContext报错，使用setTimeout

        lineChart()

        barChart()

    }, 0)

    // 在手机测试，canvas中的动画看起来很卡，性能很差

    // PC上还不错

    if (/Mobile/i.test(navigator.userAgent)) {

        //针对手机，性能做一些降级，看起来就不会那么卡了

        Chart.defaults.global.animationSteps = Chart.defaults.global.animationSteps / 6

        Chart.defaults.global.animationEasing = "linear"

    }

    &lt;/script&gt;</pre>
</div>
<h1>其他</h1>
<p>　　<a href="http://www.cnblogs.com/libinqq/archive/2008/12/09/1350773.html" rel="external nofollow noreferrer">点我：博友探讨canvas VS flash&nbsp;Silverlight &amp; 大牛作品</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq44o70q.html">iOS 图形图像动画 Core Animation</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gx0k0q.html">session和cookie的区别和联系</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jongwq.html">C&plus;&plus;中的左值与右值&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k151159.html">iOS开发&mdash;&mdash;多线程OC篇&amp;amp&semi;（十）多线程NSOperation基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y677nq.html">HTTP 错误 500&period;21 - Internal Server Error的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkngmj8.html">【ThinkingInC&plus;&plus;】52、函数内部的静态变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me017pq.html">HttpServletRequest基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k1z209.html">cv&colon;&colon;Mat类之type成员</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyn67m9.html">QQ路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wwd1rq.html">架构（四）Git简介，安装以及相关命令SourceTree</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rjmpz8.html">css3新属性运用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjd5739.html">MySQL学习（一） SQL基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy37vdq.html">UILabel部分文字可点击</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lnllq.html">深入理解Word2Vec</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdv7j09.html">Hi3518EV200音频相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm0o449.html">【LOJ】&num;2106&period; 「JLOI2015」有意义的字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlv4rk9.html">部署hadoop的开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pzenn8.html">python 用户注册用户名</a>
		</li>
						<li><a href="https://www.batexi.com/a/93j7zv08.html">id 和 instancetype 方法的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/96mkzo48.html">HTML页面布局</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1kr7n29.html">xTree学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mr3648.html">ios7上隐藏status bar</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkdv3j8.html">JAVA实现数据库数据导入&sol;导出到Excel（POI）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpjx7j9.html">AOP in Spring</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv12461q.html">Twitter Storm：单机环境的安装与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zjlxe9.html">IOS touch event  animation 转动的风车</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yw5pr8.html">struts2中token的令牌机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj1xjpq.html">黑马程序员：Java基础总结----反射</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me2oeoq.html">RSA算法优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gep1z78.html">Linux负载均衡软件LVS之三（配置篇）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
